Index: SQLBuilderBase.java
===================================================================
--- SQLBuilderBase.java	(revision 44197)
+++ SQLBuilderBase.java	(revision 44198)
@@ -1051,48 +545,58 @@
             this.subquery = subquery;
             return this;
         }
-        
+
         @Override
         public String toString() {
-            if( ! StringUtils.isEmpty(passthrough) ) {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
+            if (!StringUtils.isEmpty(passthrough)) {
                 return passthrough;
             }
-            if( ! StringUtils.isEmpty(subquery) ) {
+            if (!StringUtils.isEmpty(subquery)) {
                 return "( " + this.subquery + ") as _subquery_alias_ ";
             }
-            return this.tableName.toString();
+            return this.tableName.toString(formatter);
         }
 
     }
 
-    public class SelectColumnBuilderBase implements SelectColumnBuilder {
+    public class SelectColumnBuilderBase
+            extends AbstractStatementPart
+            implements SelectColumnBuilder {
 
         private Variable name = null;
         private String alias = null;
         private Value value = null;
         private boolean asGeometry = false;
-        
+
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.name != null ) {
+            if (this.name != null) {
                 this.name.accept(visitor, filter);
             }
-            if( this.value != null ) {
+            if (this.value != null) {
                 this.value.accept(visitor, filter);
             }
         }
 
         @Override
         public SelectColumnBuilder name(String name) {
-            String quote = config.getString(Config.quote_for_identifiers);
+            String quote = quote_for_identifiers();
             if (name.startsWith(quote)) {
                 // Remove quotes
                 name = name.substring(1, name.length() - 1);
             }
-            this.name = variable(name);
+            this.name = expression().variable(name);
             this.value = null;
             this.asGeometry = false;
             return this;
@@ -1101,17 +605,17 @@
         @Override
         public SelectColumnBuilder all() {
             this.name = null;
-            this.value = custom("*");
+            this.value = expression().custom("*");
             this.asGeometry = false;
             return this;
         }
-        
+
         @Override
         public SelectColumnBuilder as_geometry() {
             this.asGeometry = true;
             return this;
         }
-       
+
         @Override
         public SelectColumnBuilder value(Value value) {
             this.value = value;
@@ -1127,14 +631,14 @@
 
         @Override
         public String getName() {
-            return this.name.getName();
+            return this.name.name();
         }
-        
+
         @Override
         public String getAlias() {
             return this.alias;
         }
-        
+
         @Override
         public String getValue() {
             return this.alias;
@@ -1142,36 +646,47 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
-            if( this.asGeometry ) {
-                builder.append(getAsGeometry(this.name).toString());
+            if (this.asGeometry) {
+                builder.append(expression().ST_AsBinary(this.name).toString(formatter));
             } else {
-                if( this.name != null ) {
-                    builder.append(this.name.toString());
+                if (this.name != null) {
+                    builder.append(this.name.toString(formatter));
                 } else {
-                    builder.append(this.value.toString());
+                    builder.append(this.value.toString(formatter));
                 }
             }
-            if( this.alias != null ) {
+            if (this.alias != null) {
                 builder.append(" AS ");
-                builder.append(identifier(this.alias));
+                builder.append(as_identifier(this.alias));
             }
             return builder.toString();
         }
     }
 
-    public class OrderByBuilderBase implements OrderByBuilder {
+    public class OrderByBuilderBase
+            extends AbstractStatementPart
+            implements OrderByBuilder {
+
         protected String value;
         protected String custom;
         protected boolean ascending;
-        
+
         public OrderByBuilderBase() {
             this.ascending = true;
         }
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
         }
@@ -1208,18 +723,28 @@
 
         @Override
         public String toString() {
-            if( !StringUtils.isEmpty(this.custom) ) {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
+            if (!StringUtils.isEmpty(this.custom)) {
                 return this.custom;
             }
-            if( this.ascending ) {
-                return identifier(this.value) + " ASC";
+            if (this.ascending) {
+                return as_identifier(this.value) + " ASC";
             }
-            return identifier(this.value) + " DESC";
+            return as_identifier(this.value) + " DESC";
         }
     }
-    
-    public class SelectBuilderBase implements SelectBuilder {
 
+    public class SelectBuilderBase
+            extends AbstractStatement
+            implements SelectBuilder {
+
         protected FromBuilder from;
         protected ExpressionBuilder where;
         protected long limit = -1;
@@ -1235,21 +760,21 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
             for (SelectColumnBuilder column : columns) {
-                column.accept(visitor,filter);
+                column.accept(visitor, filter);
             }
-            if( this.has_from() ) {
-                this.from.accept(visitor,filter);
+            if (this.has_from()) {
+                this.from.accept(visitor, filter);
             }
-            if( this.has_where() ) {
-                this.where.accept(visitor,filter);
+            if (this.has_where()) {
+                this.where.accept(visitor, filter);
             }
-            if( this.has_order_by() ) {
+            if (this.has_order_by()) {
                 for (OrderByBuilder order : order_by) {
-                    order.accept(visitor,filter);
+                    order.accept(visitor, filter);
                 }
             }
         }
@@ -1259,7 +784,7 @@
             this.distinct = true;
             return this;
         }
-        
+
         @Override
         public SelectColumnBuilder column() {
             SelectColumnBuilder builder = createSelectColumnBuilder();
@@ -1270,7 +795,7 @@
         @Override
         public boolean has_column(String name) {
             for (SelectColumnBuilder column : columns) {
-                if( name.equals(column.getName()) ) {
+                if (name.equals(column.getName())) {
                     return true;
                 }
             }
@@ -1289,7 +814,7 @@
         public boolean has_from() {
             return this.from != null;
         }
-        
+
         @Override
         public ExpressionBuilder where() {
             if (this.where == null) {
@@ -1300,12 +825,12 @@
 
         @Override
         public boolean has_where() {
-            if( this.where == null ) {
+            if (this.where == null) {
                 return false;
             }
-            return this.where.getValue() != null;
+            return this.where.value() != null;
         }
-        
+
         @Override
         public SelectBuilder limit(long limit) {
             this.limit = limit;
@@ -1314,7 +839,7 @@
 
         @Override
         public SelectBuilder limit(Long limit) {
-            if( limit == null ) {
+            if (limit == null) {
                 this.limit = 0;
             } else {
                 this.limit = limit;
@@ -1340,7 +865,7 @@
 
         @Override
         public OrderByBuilder order_by() {
-            if( this.order_by == null ) {
+            if (this.order_by == null) {
                 this.order_by = new ArrayList<>();
             }
             OrderByBuilder order = createOrderByBuilder();
@@ -1350,17 +875,17 @@
 
         @Override
         public boolean has_order_by() {
-            if( this.order_by == null ) {
+            if (this.order_by == null) {
                 return false;
             }
             return !this.order_by.isEmpty();
         }
-        
+
         protected boolean isValid(StringBuilder message) {
-            if( message == null ) {
+            if (message == null) {
                 message = new StringBuilder();
             }
-            if( this.has_offset() && !this.has_order_by() ) {
+            if (this.has_offset() && !this.has_order_by()) {
                 // Algunos gestores de BBDD requieren que se especifique un
                 // orden para poder usar OFFSET. Como eso parece buena idea para
                 // asegurar que siempre tengamos los mismo resultados, lo exijimos
@@ -1370,15 +895,23 @@
             }
             return true;
         }
-        
+
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
-            if( !this.isValid(builder) ) {
+            if (!this.isValid(builder)) {
                 throw new IllegalStateException(builder.toString());
             }
             builder.append("SELECT ");
-            if( this.distinct ) {
+            if (this.distinct) {
                 builder.append("DISTINCT ");
             }
             boolean first = true;
@@ -1388,19 +921,19 @@
                 } else {
                     builder.append(", ");
                 }
-                builder.append(column.toString());
+                builder.append(column.toString(formatter));
             }
 
-            if ( this.has_from() ) {
+            if (this.has_from()) {
                 builder.append(" FROM ");
-                builder.append(this.from.toString());
+                builder.append(this.from.toString(formatter));
             }
-            if ( this.has_where() ) {
+            if (this.has_where()) {
                 builder.append(" WHERE ");
-                builder.append(this.where.toString());
+                builder.append(this.where.toString(formatter));
             }
-            
-            if( this.has_order_by() ) {
+
+            if (this.has_order_by()) {
                 builder.append(" ORDER BY ");
                 first = true;
                 for (OrderByBuilder item : this.order_by) {
@@ -1409,15 +942,15 @@
                     } else {
                         builder.append(", ");
                     }
-                    builder.append(item.toString());                    
-                }   
+                    builder.append(item.toString(formatter));
+                }
             }
-            
-            if ( this.has_limit() ) {
+
+            if (this.has_limit()) {
                 builder.append(" LIMIT ");
                 builder.append(this.limit);
             }
-            if ( this.has_offset() ) {
+            if (this.has_offset()) {
                 builder.append(" OFFSET ");
                 builder.append(this.offset);
             }
@@ -1426,13 +959,15 @@
         }
     }
 
-    public class DropTableBuilderBase implements DropTableBuilder {
+    public class DropTableBuilderBase
+            extends AbstractStatement
+            implements DropTableBuilder {
 
         protected TableNameBuilder table;
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -1440,18 +975,26 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            this.table.accept(visitor,filter);
+            this.table.accept(visitor, filter);
         }
-        
+
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
             boolean first = true;
-            for (String sql : toStrings()) {
-                if( StringUtils.isEmpty(sql) ) {
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
                     continue;
                 }
                 if (first) {
@@ -1466,29 +1009,34 @@
 
         @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             List<String> sqls = new ArrayList<>();
 
             sqls.add(
                     MessageFormat.format(
-                            config.getString(SQLConfig.DROP_TABLE_table),
-                            this.table.toString()
+                            STMT_DROP_TABLE_table,
+                            this.table.toString(formatter)
                     )
             );
             String sql;
-            if( config.has_functionality(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table) ) {
+            if (!StringUtils.isBlank(STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table)) {
                 if (this.table.has_schema()) {
                     sql = MessageFormat.format(
-                            config.getString(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table),
-                            string(this.table.getSchema()),
-                            string(this.table.getName())
+                            STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_schema_table,
+                            as_string(this.table.getSchema()),
+                            as_string(this.table.getName())
                     );
                 } else {
                     sql = MessageFormat.format(
-                            config.getString(SQLConfig.DELETE_GEOMETRY_COLUMN_FROM_TABLE_table),
-                            identifier(this.table.getName())
+                            STMT_DELETE_GEOMETRY_COLUMN_FROM_TABLE_table,
+                            as_identifier(this.table.getName())
                     );
                 }
-                if( !StringUtils.isEmpty(sql) ) {
+                if (!StringUtils.isEmpty(sql)) {
                     sqls.add(sql);
                 }
             }
@@ -1496,7 +1044,10 @@
         }
     }
 
-    public class GrantRoleBuilderBase implements GrantRoleBuilder {
+    public class GrantRoleBuilderBase
+            extends AbstractStatementPart
+            implements GrantRoleBuilder {
+
         protected TableNameBuilder table;
         protected String role;
         protected Set<Privilege> privileges;
@@ -1512,16 +1063,16 @@
             privileges.add(privilege);
             return this;
         }
-        
+
         @Override
         public GrantRoleBuilder select() {
-             privileges.add(Privilege.SELECT);
+            privileges.add(Privilege.SELECT);
             return this;
         }
 
         @Override
         public GrantRoleBuilder update() {
-             privileges.add(Privilege.UPDATE);
+            privileges.add(Privilege.UPDATE);
             return this;
         }
 
@@ -1562,7 +1113,7 @@
         }
 
         protected String getPrivilegeName(Privilege privilege) {
-            switch(privilege) {
+            switch (privilege) {
                 case DELETE:
                     return "DELETE";
                 case INSERT:
@@ -1582,9 +1133,17 @@
                     return "ALL";
             }
         }
-        
+
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
             boolean first = true;
             for (Privilege privilege : privileges) {
@@ -1593,30 +1152,32 @@
                 } else {
                     builder.append(", ");
                 }
-                builder.append( this.getPrivilegeName(privilege));
+                builder.append(this.getPrivilegeName(privilege));
             }
             String sql = MessageFormat.format(
-                    config.getString(SQLConfig.GRANT_privileges_ON_table_TO_role),
+                    STMT_GRANT_privileges_ON_table_TO_role,
                     builder.toString(),
-                    table.toString(),
+                    table.toString(formatter),
                     role
             );
             return sql;
         }
     }
-    
-    public class GrantBuilderBase implements GrantBuilder {
 
+    public class GrantBuilderBase
+            extends AbstractStatement
+            implements GrantBuilder {
+
         protected TableNameBuilder table;
         protected Map<String, GrantRoleBuilder> roles;
 
         public GrantBuilderBase() {
             this.roles = new HashMap<>();
         }
-        
+
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -1624,18 +1185,18 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table!= null ) {
-                this.table.accept(visitor,filter);
+            if (this.table != null) {
+                this.table.accept(visitor, filter);
             }
         }
-        
+
         @Override
         public GrantRoleBuilder role(String role) {
             GrantRoleBuilder roleBuilder = this.roles.get(role);
-            if( roleBuilder == null ) {
+            if (roleBuilder == null) {
                 roleBuilder = createGrantRoleBuilder(this.table(), role);
                 this.roles.put(role, roleBuilder);
             }
@@ -1644,10 +1205,18 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             StringBuilder builder = new StringBuilder();
             boolean first = true;
-            for (String sql : toStrings()) {
-                if( StringUtils.isEmpty(sql) ) {
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
                     continue;
                 }
                 if (first) {
@@ -1662,16 +1231,23 @@
 
         @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             List<String> sqls = new ArrayList<>();
             for (GrantRoleBuilder role : roles.values()) {
-                sqls.add(role.toString());
+                sqls.add(role.toString(formatter));
             }
             return sqls;
         }
     }
 
-    public class UpdateColumnBuilderBase extends InsertColumnBuilderBase implements UpdateColumnBuilder {
-        
+    public class UpdateColumnBuilderBase
+            extends InsertColumnBuilderBase
+            implements UpdateColumnBuilder {
+
         public UpdateColumnBuilderBase() {
             super();
         }
@@ -1685,11 +1261,13 @@
         public UpdateColumnBuilder with_value(Value value) {
             return (UpdateColumnBuilder) super.with_value(value);
         }
-        
+
     }
-    
-    public class UpdateBuilderBase implements UpdateBuilder {
 
+    public class UpdateBuilderBase
+            extends AbstractStatement
+            implements UpdateBuilder {
+
         protected ExpressionBuilder where;
         protected List<UpdateColumnBuilder> columns;
         protected TableNameBuilder table;
@@ -1700,16 +1278,16 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
             for (UpdateColumnBuilder column : columns) {
                 column.accept(visitor, filter);
             }
-            if( this.has_where() ) {
+            if (this.has_where()) {
                 this.where.accept(visitor, filter);
             }
         }
@@ -1724,7 +1302,7 @@
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -1736,7 +1314,7 @@
             this.columns.add(column);
             return column;
         }
-        
+
         @Override
         public boolean has_where() {
             return this.where != null;
@@ -1744,6 +1322,14 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             /*
              * UPDATE [ ONLY ] table [ [ AS ] alias ] SET { column = { expression |
              * DEFAULT } | ( column [, ...] ) = ( { expression | DEFAULT } [, ...] )
@@ -1759,23 +1345,23 @@
                 } else {
                     columnsAndValues.append(", ");
                 }
-                columnsAndValues.append(identifier(column.getName()));
+                columnsAndValues.append(as_identifier(column.getName()));
                 columnsAndValues.append(" = ");
-                columnsAndValues.append(column.getValue().toString());
+                columnsAndValues.append(column.getValue().toString(formatter));
             }
-            
+
             String sql;
-            if ( this.has_where() ) {
+            if (this.has_where()) {
                 sql = MessageFormat.format(
-                        config.getString(SQLConfig.UPDATE_table_SET_columnsAndValues_WHERE_expresion),
-                        this.table.toString(),
+                        STMT_UPDATE_table_SET_columnsAndValues_WHERE_expresion,
+                        this.table.toString(formatter),
                         columnsAndValues.toString(),
-                        this.where.toString()
+                        this.where.toString(formatter)
                 );
             } else {
                 sql = MessageFormat.format(
-                        config.getString(SQLConfig.UPDATE_table_SET_columnsAndValues),
-                        this.table.toString(),
+                        STMT_UPDATE_table_SET_columnsAndValues,
+                        this.table.toString(formatter),
                         columnsAndValues.toString()
                 );
             }
@@ -1783,7 +1369,9 @@
         }
     }
 
-    public class DeleteBuilderBase implements DeleteBuilder {
+    public class DeleteBuilderBase
+            extends AbstractStatement
+            implements DeleteBuilder {
 
         protected ExpressionBuilder where;
         protected TableNameBuilder table;
@@ -1793,13 +1381,13 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
-            if( this.has_where() ) {
+            if (this.has_where()) {
                 this.where.accept(visitor, filter);
             }
         }
@@ -1814,7 +1402,7 @@
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -1827,28 +1415,38 @@
 
         @Override
         public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
             /*
              * DELETE FROM table_name
              * WHERE some_column=some_value; 
              */
             String sql;
-            if( this.has_where() ) {
+            if (this.has_where()) {
                 sql = MessageFormat.format(
-                        config.getString(SQLConfig.DELETE_FROM_table_WHERE_expresion),
-                        this.table.toString(),
-                        this.where.toString()
+                        STMT_DELETE_FROM_table_WHERE_expresion,
+                        this.table.toString(formatter),
+                        this.where.toString(formatter)
                 );
             } else {
                 sql = MessageFormat.format(
-                        config.getString(SQLConfig.DELETE_FROM_table),
-                        this.table.toString()
+                        STMT_DELETE_FROM_table,
+                        this.table.toString(formatter)
                 );
             }
             return sql;
         }
     }
 
-    public class CreateIndexBuilderBase implements CreateIndexBuilder {
+    public class CreateIndexBuilderBase
+            extends AbstractStatement
+            implements CreateIndexBuilder {
 
         protected boolean ifNotExist = false;
         protected boolean isUnique = false;
@@ -1856,11 +1454,11 @@
         protected boolean isSpatial = false;
         protected TableNameBuilder table;
         protected final List<String> columns;
-        
+
         public CreateIndexBuilderBase() {
             this.columns = new ArrayList<>();
         }
-        
+
         @Override
         public CreateIndexBuilder unique() {
             this.isUnique = true;
@@ -1893,7 +1491,7 @@
 
         @Override
         public TableNameBuilder table() {
-            if( table == null ) {
+            if (table == null) {
                 table = createTableNameBuilder();
             }
             return table;
@@ -1901,35 +1499,66 @@
 
         @Override
         public void accept(Visitor visitor, VisitorFilter filter) {
-            if( filter.accept(this) ) {
+            if (filter.accept(this)) {
                 visitor.visit(this);
             }
-            if( this.table != null ) {
+            if (this.table != null) {
                 this.table.accept(visitor, filter);
             }
         }
-        
+
         @Override
+        public String toString() {
+            return this.toString(formatter());
+        }
+
+        @Override
+        public String toString(Formatter<Value> formatter) {
+            if (formatter.canApply(this)) {
+                return formatter.format(this);
+            }
+            StringBuilder builder = new StringBuilder();
+            boolean first = true;
+            for (String sql : toStrings(formatter)) {
+                if (StringUtils.isEmpty(sql)) {
+                    continue;
+                }
+                if (first) {
+                    first = false;
+                } else {
+                    builder.append("; ");
+                }
+                builder.append(sql);
+            }
+            return builder.toString();
+        }
+
+        @Override
         public List<String> toStrings() {
+            return this.toStrings(formatter());
+        }
+
+        @Override
+        public List<String> toStrings(Formatter formatter) {
             StringBuilder builder = new StringBuilder();
             builder.append("CREATE ");
-            if( this.isUnique ) {
+            if (this.isUnique) {
                 builder.append("UNIQUE ");
             }
             builder.append("INDEX ");
-            if( this.ifNotExist ) {
+            if (this.ifNotExist) {
                 builder.append("IF NOT EXISTS ");
             }
-            builder.append(identifier(this.indexName));
+            builder.append(as_identifier(this.indexName));
             builder.append(" ON ");
-            builder.append(this.table.toString());
-            if( this.isSpatial ) {
+            builder.append(this.table.toString(formatter));
+            if (this.isSpatial) {
                 builder.append(" USING GIST ");
             }
             builder.append(" ( ");
             boolean is_first_column = true;
-            for( String column : this.columns) {
-                if( is_first_column ) {
+            for (String column : this.columns) {
+                if (is_first_column) {
                     is_first_column = false;
                 } else {
                     builder.append(", ");
